////////////////////////////////////////////////////////////////////////
// channels_widget.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.channels_widget")

// <%pre>
#line 1 "channels_widget.ecpp"

#include <exception.h>
#include <setup.h>
#include <stringhelpers.h>
#include <tools.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("channels_widget");

static const char* rawData = "\000\000\000,\000\000\000:\000\000\000@\000\000\000A\000\000\000C\000\000\000V\000\000"
  "\000W\000\000\000X\000\000\000Z\000\000\000d\000\000\000n<select name=\"\" id=\"\">\n    <option value=\"\">: </optio"
  "n>\n</select>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("channels_widget " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string name = qparam.get< std::string >("name", ( "channel"));
std::string selected = qparam.get< std::string >("selected");
std::string onchange = qparam.get< std::string >("onchange");
bool channelid = qparam.get< bool >("channelid", ( false));
  // </%args>

#line 17 "channels_widget.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
  // <%cpp>
#line 19 "channels_widget.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  reply.out() << _tntChunks[0]; // <select name="
#line 26 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[1]; // " id="
#line 26 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << _tntChunks[2]; // "
#line 26 "channels_widget.ecpp"
  if ( !onchange.empty() )
    reply.out() <<  cToSvConcat(" onchange=\"", onchange, "\"") ;
  reply.out() << _tntChunks[3]; // >\n
#line 27 "channels_widget.ecpp"

  tChannelID selected_ChannelID = tChannelID::FromString(selected.c_str() );
  LOCK_CHANNELS_READ;
  for (const cChannel *listChannel = Channels->First(); listChannel; listChannel = Channels->Next(listChannel) ) {
    if (listChannel->GroupSep() || !listChannel->Name() || *listChannel->Name() == '\0') continue;

  reply.out() << _tntChunks[4]; //     <option value="
#line 33 "channels_widget.ecpp"
  reply.out() << ( channelid ? cToSvConcat(listChannel->GetChannelID()):cToSvInt(listChannel->Number()) );
  reply.out() << _tntChunks[5]; // "
#line 33 "channels_widget.ecpp"
  if ( selected_ChannelID == listChannel->GetChannelID() )
    reply.out() <<  " selected=\"selected\"" ;
  reply.out() << _tntChunks[6]; // >
#line 33 "channels_widget.ecpp"
  reply.out() << ( cToSvInt(listChannel->Number()) );
  reply.out() << _tntChunks[7]; // : 
#line 33 "channels_widget.ecpp"
  reply.sout() << ( listChannel->Name() );
  reply.out() << _tntChunks[8]; // </option>\n
#line 34 "channels_widget.ecpp"
 }

  reply.out() << _tntChunks[9]; // </select>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
