////////////////////////////////////////////////////////////////////////
// ibox.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.ibox")

// <%pre>
#line 1 "ibox.ecpp"


#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <recman.h>
#include <timerconflict.h>

#include <vdr/menu.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("ibox");

static const char* rawData = "\000\000\000\030\000\000\000\031\000\000\000\032\000\000\000\033\000\000\000\034\000\000"
  "\000\035\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("ibox " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
int update = qparam.get< int >("update");
  // </%args>

#line 18 "ibox.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 19 "ibox.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
#line 20 "ibox.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_SHARED_VAR(TimerConflictNotifier, timerNotifier, ());   // <%session> TimerConflictNotifier timerNotifier
  _tnt_ignore_unused<timerNotifier_type>(timerNotifier);
  // <%cpp>
#line 22 "ibox.ecpp"

  if (!logged_in && LiveSetup().UseAuth()) {
    cToSvConcat targetUrl = "/login.html?redirect=";
    targetUrl.appendUrlEscaped(request.getQuery());
    return reply.redirect(targetUrl.data());
  }

  tChannelID prev_chan;
  tChannelID next_chan;
  reply.setContentType( "application/xml" );

  if (update_status != update) {
    update_status = update;
  }

  std::string infoMsg;
  cSv infoUrl;

  if (timerNotifier.ShouldNotify()) {
    infoMsg = timerNotifier.Message();
    infoUrl = "timerconflicts.html";
  }

  const char* NowReplaying = cReplayControl::NowReplaying();

  EpgInfo epgEvent;

  if (NowReplaying) {
    // is is OK to lock here, because CreateEpgInfo will *not* lock other lists
    LOCK_RECORDINGS_READ;
    const cRecording *recording = Recordings->GetByName(NowReplaying);
    if (recording) {
      epgEvent.CreateEpgInfo(
        concat("recording_", cToSvXxHash128(XXH3_128bits(NowReplaying, strlen(NowReplaying))) ),
        recording,
        tr("playing recording"));
    }
  }
  else {
    cSv CHANNEL_STR("channel");
    if (cDevice::CurrentChannel()) {
      const int SKIP_GAP = 1;
      LOCK_CHANNELS_READ;
      const cChannel* Channel = Channels->GetByNumber(cDevice::CurrentChannel());
      const cChannel* tmp = Channels->GetByNumber(Channels->GetPrevNormal(cDevice::CurrentChannel()), -SKIP_GAP);
#if VDRVERSNUM >= 20606
      if (tmp)
#else
      if (tmp && cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() )
#endif
        prev_chan = tmp->GetChannelID();
      tmp = Channels->GetByNumber(Channels->GetNextNormal(cDevice::CurrentChannel()), SKIP_GAP);
#if VDRVERSNUM >= 20606
      if (tmp)
#else
      if (tmp && cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() )
#endif
        next_chan = tmp->GetChannelID();

      LOCK_SCHEDULES_READ;
      const cSchedule *Schedule = Schedules->GetSchedule(Channel);

      if (Schedule) {
        const cEvent *Event = Schedule->GetPresentEvent();
        if (Event) {
          epgEvent.CreateEpgInfo(Channel, Event, CHANNEL_STR);
        } else {
          epgEvent.CreateEpgInfo(CHANNEL_STR, Channel->Name(),
                            tr("no epg info for current event!"));
        }
      }
      else {
        epgEvent.CreateEpgInfo(CHANNEL_STR, Channel->Name(),
                          tr("no epg info for current channel!"));
      }
    }
    else {
      cSv chanName(tr("no current channel!"));
      epgEvent.CreateEpgInfo(CHANNEL_STR, chanName, chanName);
    }
  }
  if (epgEvent.Id().empty() ) {
    epgEvent.CreateEpgInfo("error", "no current channel!", "error retrieving status info!");
  }
  else {
    if (prev_chan.Valid() && next_chan.Valid())
    {

  // <& xmlresponse.ibox ...
  { 
#line 110 "ibox.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "caption", (epgEvent.Caption()));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "currentTime", (epgEvent.CurrentTime(tr("%I:%M:%S %p"))));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "duration", (epgEvent.StartTime(tr("%I:%M %p")) + std::string(" - ") + epgEvent.EndTime(tr("%I:%M %p"))));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "elapsed", (epgEvent.Elapsed()));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "infoMsg", (infoMsg));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "infoUrl", (infoUrl));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "next_chan", (next_chan));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "prev_chan", (prev_chan));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "title", (epgEvent.Title()));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "type", (epgEvent.Id()));
#line 110 "ibox.ecpp"
    _tnt_cq0.add( "update", (update_status));
#line 110 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[0]; // \n
#line 111 "ibox.ecpp"

    }
    else if (prev_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 115 "ibox.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "caption", (epgEvent.Caption()));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "currentTime", (epgEvent.CurrentTime(tr("%I:%M:%S %p"))));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "duration", (epgEvent.StartTime(tr("%I:%M %p")) + std::string(" - ") + epgEvent.EndTime(tr("%I:%M %p"))));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "elapsed", (epgEvent.Elapsed()));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "infoMsg", (infoMsg));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "infoUrl", (infoUrl));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "prev_chan", (prev_chan));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "title", (epgEvent.Title()));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "type", (epgEvent.Id()));
#line 115 "ibox.ecpp"
    _tnt_cq1.add( "update", (update_status));
#line 115 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[1]; // \n
#line 116 "ibox.ecpp"

    }
    else if (next_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 120 "ibox.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "caption", (epgEvent.Caption()));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "currentTime", (epgEvent.CurrentTime(tr("%I:%M:%S %p"))));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "duration", (epgEvent.StartTime(tr("%I:%M %p")) + std::string(" - ") + epgEvent.EndTime(tr("%I:%M %p"))));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "elapsed", (epgEvent.Elapsed()));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "infoMsg", (infoMsg));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "infoUrl", (infoUrl));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "next_chan", (next_chan));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "title", (epgEvent.Title()));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "type", (epgEvent.Id()));
#line 120 "ibox.ecpp"
    _tnt_cq2.add( "update", (update_status));
#line 120 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[2]; // \n
#line 121 "ibox.ecpp"

    }
    else {

  // <& xmlresponse.ibox ...
  { 
#line 125 "ibox.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "caption", (epgEvent.Caption()));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "currentTime", (epgEvent.CurrentTime(tr("%I:%M:%S %p"))));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "duration", (epgEvent.StartTime(tr("%I:%M %p")) + std::string(" - ") + epgEvent.EndTime(tr("%I:%M %p"))));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "elapsed", (epgEvent.Elapsed()));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "infoMsg", (infoMsg));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "infoUrl", (infoUrl));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "title", (epgEvent.Title()));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "type", (epgEvent.Id()));
#line 125 "ibox.ecpp"
    _tnt_cq3.add( "update", (update_status));
#line 125 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n
#line 126 "ibox.ecpp"

    }
  }

  reply.out() << _tntChunks[4]; // \n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
