////////////////////////////////////////////////////////////////////////
// whats_on.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.whats_on")

// <%pre>
#line 1 "whats_on.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <epgsearch.h>

using namespace vdrlive;

static const size_t maximumTruncDescriptionLength = 150;  // characters for the description in the "boxes"


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// HTML output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class whats_on_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        whats_on_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    whats_on_actions_type whats_on_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("whats_on");

static const char* rawData = "\000\000\001\134\000\000\001]\000\000\001^\000\000\001_\000\000\001\315\000\000\001\332"
  "\000\000\001\337\000\000\001\344\000\000\002\261\000\000\003}\000\000\003\374\000\000\004\001\000\000\004\033\000\000"
  "\004\256\000\000\004\324\000\000\005D\000\000\005F\000\000\005G\000\000\005\265\000\000\0060\000\000\006H\000\000\006"
  "|\000\000\006\263\000\000\006\344\000\000\007\033\000\000\007\034\000\000\007S\000\000\007T\000\000\007Y\000\000\007"
  "\231\000\000\007\254\000\000\007\313\000\000\010\032\000\000\010H\000\000\010\222\000\000\010\225\000\000\010\316\000"
  "\000\010\332\000\000\010\333\000\000\010\374\000\000\t\035\000\000\t)\000\000\tZ\000\000\t[\000\000\tz\000\000\t\241"
  "\000\000\t\334\000\000\n\003\000\000\n\005\000\000\n\006\000\000\n+\000\000\n:\000\000\nW\000\000\nX\000\000\nY\000"
  "\000\n[\000\000\ne\000\000\n\215\000\000\n\234\000\000\n\306\000\000\n\357\000\000\n\377\000\000\013,\000\000\013."
  "\000\000\013\236\000\000\013\250\000\000\013\257\000\000\013\262\000\000\013\274\000\000\013\356\000\000\013\360\000"
  "\000\014;\000\000\014x\000\000\014\202\000\000\014\253\000\000\014\255\000\000\014\315\000\000\014\371\000\000\015"
  "\005\000\000\015\022\000\000\015\024\000\000\015\031\000\000\015C\000\000\015O\000\000\015\134\000\000\015^\000\000"
  "\015c\n\n\n\n<html>\n  <head>\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n    <title"
  ">VDR-Live - </title>\n    \n    \n    \n    <script type=\"text/javascript\"><!--\n    function showtime(selection)\n"
  "    {\n      if (selection.options[selection.selectedIndex].value != \"\")\n        window.location.href = \"whats_on"
  ".html\?type=at&mode=&fixtime=\" + selection.options[selection.selectedIndex].value;\n    }\n    function showspectime"
  "(selection)\n    {\n      if (selection.value != \"\")\n        window.location.href = \"whats_on.html\?type=at&mode="
  "&attime=\" + selection.value;\n    }\n    //--></script>\n  </head>\n  <body onload=\"adjustHeader()\" onresize=\"adj"
  "ustHeader()\">\n    \n    \n    <div class=\"inhalt\">\n      <table class=\"listing\" cellspacing=\"0\" cellpadding="
  "\"0\">\n        <tr class=\"head\">\n          <td colspan=\"9\"><div class=\"boxheader\"><div><div></div></div></div"
  "></td>\n        </tr>\n      <div class=\"event\">\n        <div class=\"station\">\n          <div><div><div><a href"
  "=\"schedule.html\?channel=\" ></a></div></div></div>\n        </div>\n        <div class=\"content\">\n          <div"
  " class=\"tools\">\n            \n          </div>\n          <div class=\"whatson_info\">\n            <div class=\"i"
  "nfo nowrap\"><div class=\"date margin_right\"></div><div class=\"time\"></div></div>\n            <div class=\"progre"
  "ss\"><div></div></div>\n            <div class=\"title withmargin\"></div>\n            <div class=\"short withmargin"
  "\"></div>\n            <div class=\"description withmargin\">\n              ...</div><div class=\"more withmargin\">"
  "<a ></a>\n            </div>\n          </div>\n        </div>\n      </div>\n      <tr>\n        \n        <td class"
  "=\"topaligned \">\n          <div class=\"withmargin\">\n            <div class=\"nomargin nowrap\"></div>\n         "
  "   <div class=\"progress\"><div></div></div>\n          </div>\n        </td>\n        <td class=\"topaligned \">\n  "
  "          <div class=\"more withmargin\">\n            <a\n            \n            ><span class=\"title\"></span><b"
  "r /><span class=\"short\"></span></a>\n            <div class=\"withmargin\">\n            \n          </div>\n      "
  "  </td>\n        <td class=\"topaligned rightcol \"><div class=\"station withmargin\"><span class=\"channel_id\"></sp"
  "an> <a href=\"schedule.html\?channel=\" ></a></div>\n        </td>\n      </tr>\n      </table>\n    </div>\n  </body"
  ">\n</html>\n\n\n\n\n<a class=\"\" href=\"whats_on.html\?type=now&amp;mode=\" id=\"nowhref\"></a>\n<span class=\"sep\""
  ">|</span>\n<a class=\"\" href=\"whats_on.html\?type=next&amp;mode=\" id=\"nexthref\"></a>\n<span class=\"sep\">|</spa"
  "n>\n<span class=\"\"></span>\n<select name=\"userdeftimes\" size=\"1\" id=\"userdeftimes\" onchange=\"showtime(this)"
  "\">\n  <option value=\"0\"/>\n  <option value=\"\"> </option>\n</select>\n<span class=\"sep\">|</span>\n<span class="
  "\"\"></span>\n<input type=\"text\" size=\"6\" name=\"spectime\" id=\"spectime\" value = \"\" onchange=\"showspectime("
  "this)\"/>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=favs&amp;mode=\"></a>\n<span class="
  "\"sep\">|</span>\n<a href=\"whats_on.html\?mode=detail&amp;type=&amp;attime=&amp;fixtime=\"></a>\n<a href=\"whats_on."
  "html\?mode=list&amp;type=&amp;attime=&amp;fixtime=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    whats_on_actions(*this, "whats_on_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string type = qparam.get< std::string >("type", ( "now"));
std::string mode = qparam.get< std::string >("mode");
std::string attime = qparam.get< std::string >("attime");
std::string fixtime = qparam.get< std::string >("fixtime");
  // </%args>

#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
  reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
  tnt::Savepoint spoint( reply );

  // </%include>
#line 34 "whats_on.ecpp"

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) {
  cToSvConcat<0> targetUrl = "/login.html?redirect=";
  targetUrl.appendUrlEscaped(request.getQuery());
  return reply.redirect(targetUrl.data());
}


std::string head;
time_t seektime = 0;
std::string displaytime;
std::string headTime;
std::string headDate;

if (mode.empty())
  mode = LiveSetup().GetLastWhatsOnListMode();
else
  LiveSetup().SetLastWhatsOnListMode(mode);

current_type = type;
current_mode = mode;
current_attime = attime;
current_fixtime = fixtime;

char const * timeFormat = tr("%I:%M %p");
char const * dateFormat = tr("%A, %x");
if (mode == "detail") {
  dateFormat = tr("%a, %x");
}

if (type == "now") {
  headTime = std::string(cToSvDateTime(timeFormat, time(0)));
  headDate = std::string(cToSvDateTime(dateFormat, time(0)));
  head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + " " + headTime;
} else if (type == "next") {
  headTime = std::string(cToSvDateTime(timeFormat, time(0) + 3600));
  headDate = std::string(cToSvDateTime(dateFormat, time(0) + 3600));
  head = tr("What's on next?");
} else if (type == "at") {
  if (attime != "")
    displaytime = ExpandTimeString(attime);
  else if (fixtime != "")
    displaytime = ExpandTimeString(fixtime);
  current_displaytime = displaytime;

  seektime = GetTimeT(displaytime);
  if (seektime - time(0) + 3600 < 0) // if wanted time is past more then 1h, then use tomorrow
    seektime += SECSINDAY;
  headTime = std::string(cToSvDateTime(timeFormat, seektime));
  headDate = std::string(cToSvDateTime(dateFormat, seektime));
  head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + std::string(" ") + headTime;
} else if (type == "favs") {
  head = tr("Favorites");
}


  // <& pageelems.doc_type ...
  { 
#line 91 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 91 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 95 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 96 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 96 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 97 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 97 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 98 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 98 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n    <script type="text/javascript"><!--\n    function showtime(selection)\n    {\n      if (selection.options[selection.selectedIndex].value != "")\n        window.location.href = "whats_on.html\?type=at&mode=
#line 103 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[8]; // &fixtime=" + selection.options[selection.selectedIndex].value;\n    }\n    function showspectime(selection)\n    {\n      if (selection.value != "")\n        window.location.href = "whats_on.html\?type=at&mode=
#line 108 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[9]; // &attime=" + selection.value;\n    }\n    //--></script>\n  </head>\n  <body onload="adjustHeader()" onresize="adjustHeader()">\n    
  // <& pageelems.logo ...
  { 
#line 113 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 113 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n    
  // <& menu ...
  { 
#line 114 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 114 "whats_on.ecpp"
    _tnt_cq5.add( "active", ("whats_on"));
#line 114 "whats_on.ecpp"
    _tnt_cq5.add( "component", ("whats_on.whats_on_actions"));
#line 114 "whats_on.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n    <div class="inhalt">\n
#line 116 "whats_on.ecpp"
      if (mode == "list") {

  reply.out() << _tntChunks[12]; //       <table class="listing" cellspacing="0" cellpadding="0">\n        <tr class="head">\n          <td colspan="9"><div class="boxheader"><div><div>
#line 119 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[13]; // </div></div></div></td>\n        </tr>\n
#line 121 "whats_on.ecpp"
      }

#line 122 "whats_on.ecpp"

  std::vector<EpgInfo> eventList;

  // collect the broadcasts
  if (type != "favs")
  {
    {
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      for (const cChannel *Channel = Channels->First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = Channels->Next(Channel)) {
        if (Channel->GroupSep()) {
          continue;
        }
        const cSchedule *Schedule = Schedules->GetSchedule(Channel);
        if (!Schedule) {
          continue;
        }
        const cEvent *Event = nullptr;
        if (type == "now")
          Event = Schedule->GetPresentEvent();
        else if (type == "next")
          Event = Schedule->GetFollowingEvent();
        else if (type == "at")
          Event = Schedule->GetEventAround(seektime);

        if (!Event && !LiveSetup().GetShowChannelsWithoutEPG()) continue;

        eventList.emplace_back(Channel, Event);
      }
    }
  }
  else // get favorite broadcasts from epgsearch
  {
    SearchResults results;
    SearchTimers timers;
    for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
      if (!timer->UseInFavorites()) continue;
      SearchResults curresults;
      curresults.GetByID(timer->Id());
      results.merge(curresults);
    }
    time_t now = time(NULL);
    for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
      long diff = result->StartTime() - now;
      if (labs(diff) >= 24*60*60) continue; // skip broadcasts more than a day away
      LOCK_CHANNELS_READ;
      LOCK_SCHEDULES_READ;
      const cChannel* Channel = result->GetChannel(Channels);
      if (!Channel) continue;
      eventList.emplace_back(Channel, result->GetEvent(Channel, Schedules) );
    }
  }

  // display broadcasts
  for(std::vector<EpgInfo>::size_type i = 0; i < eventList.size(); ++i) {
    EpgInfoPtr epgEvent = &(eventList[i]);

    bool truncated = false;
    cToSvConcat longDescription;
    AppendHtmlEscapedAndCorrectNonUTF8(longDescription, StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars(), truncated));
    if (truncated) longDescription << " ...";
    longDescription << "<br/><br/>" << tr("Click to view details.");

    std::string truncDescription(StringWordTruncate(epgEvent->LongDescr(), maximumTruncDescriptionLength, truncated));
    int chNumber = epgEvent->ChannelNumber();

    std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
    std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
    std::string startDate(epgEvent->StartTime(tr("%a, %x")));

    std::string timeSpan(startTime + " - " + endTime);

    if (startTime.empty() && endTime.empty()) {
      timeSpan = mode=="detail" ? headTime : std::string();
      startDate = headDate;
    }
    if (mode == "detail") {

  reply.out() << _tntChunks[14]; //       <div class="event">\n        <div class="station">\n          <div><div><div><a href="schedule.html\?channel=
#line 202 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
  reply.out() << _tntChunks[15]; // " 
  // <& tooltip.hint ...
  { 
#line 202 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 202 "whats_on.ecpp"
    _tnt_cq6.add( "text", (tr("View the schedule of this channel")));
#line 202 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[16]; // >
#line 202 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
#line 202 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 202 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[17]; // </a></div></div></div>\n        </div>\n        <div class="content">\n          <div class="tools">\n            
  // <& pageelems.epg_tool_box ...
  { 
#line 206 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 206 "whats_on.ecpp"
    _tnt_cq7.add( "detail", (1));
#line 206 "whats_on.ecpp"
    _tnt_cq7.add( "endTime", (epgEvent->GetEndTime()));
#line 206 "whats_on.ecpp"
    _tnt_cq7.add( "epgid", (epgEvent->Id()));
#line 206 "whats_on.ecpp"
    _tnt_cq7.add( "startTime", (epgEvent->GetStartTime()));
#line 206 "whats_on.ecpp"
    _tnt_cq7.add( "title", (epgEvent->Title()));
#line 206 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n          </div>\n          <div class="whatson_info">\n            <div class="info nowrap"><div class="date margin_right">
#line 209 "whats_on.ecpp"
  reply.sout() << ( (startDate) );
  reply.out() << _tntChunks[19]; // </div><div class="time">
#line 209 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[20]; // </div></div>\n            <div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 210 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 210 "whats_on.ecpp"
    _tnt_cq8.add( "duration", (epgEvent->Duration()));
#line 210 "whats_on.ecpp"
    _tnt_cq8.add( "progress", (epgEvent->Elapsed()));
#line 210 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[21]; // </div></div>\n            <div class="title withmargin">
#line 211 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[22]; // </div>\n            <div class="short withmargin">
#line 212 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[23]; // </div>\n            <div class="description withmargin">
#line 213 "whats_on.ecpp"
  reply.sout() << ( truncDescription );
  reply.out() << _tntChunks[24]; // \n
#line 214 "whats_on.ecpp"
            if (truncated) {

  reply.out() << _tntChunks[25]; //               ...</div><div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 215 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 215 "whats_on.ecpp"
    _tnt_cq9.add( "text", (longDescription));
#line 215 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 215 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 215 "whats_on.ecpp"
    _tnt_cq10.add( "domId", (epgEvent->Id()));
#line 215 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[26]; // >
#line 215 "whats_on.ecpp"
  reply.sout() << ( tr("more") );
  reply.out() << _tntChunks[27]; // </a>\n
#line 216 "whats_on.ecpp"
            }

  reply.out() << _tntChunks[28]; //             </div>\n          </div>\n        </div>\n      </div>\n
#line 221 "whats_on.ecpp"

    } else { // mode == "list"
      bool lastCurrentChanel = i == (eventList.size() - 1);
      tChannelID chanId;
      tEventID eventId;
      EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);

      // Searching for channel logos
      cToSvConcat<0> chanlogoimg;
      if (!LiveSetup().GetChanLogoDir().empty() ) {
        std::string chanlogofile = std::string(cToSvReplace(epgEvent->Caption(), "/", "_").concat(".png"));
        std::string chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
        struct stat chanfilebuf;
        bool logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile, g_locale));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (!logo_available) {
//          chanlogofile = StringReplace(epgEvent->Caption(), "/", "~") + ".png";
          chanlogofile = std::string(cToSvToLower(cToSvReplace(epgEvent->Caption(), "/", "~").concat(".png"), g_locale));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
        if (logo_available) {
          chanlogoimg.append("<img src=\"chanlogos/");
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, chanlogofile);
          chanlogoimg.append("\" alt=\"");
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, epgEvent->Caption());
          chanlogoimg.append("\" loading=\"lazy\" class=\"channel_logo\">");
        }
      }

  reply.out() << _tntChunks[29]; //       <tr>\n        
  // <& pageelems.epg_tool_box ...
  { 
#line 256 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "detail", (0));
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "endTime", (epgEvent->GetEndTime()));
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "epgid", (epgEvent->Id()));
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "lastCurrentChanel", (lastCurrentChanel ? 1 : 0));
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "startTime", (epgEvent->GetStartTime()));
#line 256 "whats_on.ecpp"
    _tnt_cq11.add( "title", (epgEvent->Title()));
#line 256 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n        <td class="topaligned 
#line 257 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[31]; // ">\n          <div class="withmargin">\n            <div class="nomargin nowrap">
#line 259 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[32]; // </div>\n            <div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 260 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 260 "whats_on.ecpp"
    _tnt_cq12.add( "duration", (epgEvent->Duration()));
#line 260 "whats_on.ecpp"
    _tnt_cq12.add( "progress", (epgEvent->Elapsed()));
#line 260 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[33]; // </div></div>\n          </div>\n        </td>\n        <td class="topaligned 
#line 263 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[34]; // ">\n
#line 264 "whats_on.ecpp"
          if (eventId != 0) {

  reply.out() << _tntChunks[35]; //             <div class="more withmargin">\n            <a\n
#line 267 "whats_on.ecpp"
            if (!longDescription.empty()) {

  reply.out() << _tntChunks[36]; //             
  // <& tooltip.hint ...
  { 
#line 268 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 268 "whats_on.ecpp"
    _tnt_cq13.add( "text", (longDescription));
#line 268 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 268 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 268 "whats_on.ecpp"
    _tnt_cq14.add( "domId", (epgEvent->Id()));
#line 268 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[37]; // \n
#line 269 "whats_on.ecpp"
            }

  reply.out() << _tntChunks[38]; //             ><span class="title">
#line 270 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[39]; // </span><br /><span class="short">
#line 270 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[40]; // </span></a>\n
#line 271 "whats_on.ecpp"
          } else {

  reply.out() << _tntChunks[41]; //             <div class="withmargin">\n            
#line 273 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[42]; // \n
#line 274 "whats_on.ecpp"
          }

  reply.out() << _tntChunks[43]; //           </div>\n        </td>\n
#line 277 "whats_on.ecpp"

      cToSvConcat hint(epgEvent->Caption().data(), "<br>", tr("View the schedule of this channel"));

  reply.out() << _tntChunks[44]; //         <td class="topaligned rightcol 
#line 280 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[45]; // "><div class="station withmargin"><span class="channel_id">
#line 280 "whats_on.ecpp"
  reply.sout() << ( cToSvInt(chNumber) );
#line 280 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
  reply.out() << _tntChunks[46]; // </span> <a href="schedule.html\?channel=
#line 280 "whats_on.ecpp"
  reply.sout() << ( cToSvInt(chNumber) );
  reply.out() << _tntChunks[47]; // " 
  // <& tooltip.hint ...
  { 
#line 280 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 280 "whats_on.ecpp"
    _tnt_cq15.add( "text", (hint));
#line 280 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[48]; // >
#line 280 "whats_on.ecpp"
  reply.out() << ( chanlogoimg );
#line 280 "whats_on.ecpp"
  reply.sout() << ( chanlogoimg.empty()?epgEvent->Caption():"" );
  reply.out() << _tntChunks[49]; // </a></div>\n        </td>\n      </tr>\n
#line 283 "whats_on.ecpp"
  }

#line 284 "whats_on.ecpp"

  }

#line 287 "whats_on.ecpp"
  if (mode == "list") {

  reply.out() << _tntChunks[50]; //       </table>\n
#line 289 "whats_on.ecpp"
   }

  reply.out() << _tntChunks[51]; //     </div>\n  </body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[52]; // \n
#line 5 "page_exit.eh"

  spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
  tnt::QueryParams param = qparam;
  param.add( "pageTitle", pageTitle );
  param.add( "errorMessage", ex.what() );
  callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::whats_on_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on::whats_on_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[55]; // <a class="
#line 298 "whats_on.ecpp"
  if ( current_type == "now" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[56]; // " href="whats_on.html\?type=now&amp;mode=
#line 298 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[57]; // " id="nowhref">
#line 298 "whats_on.ecpp"
  reply.sout() << ( tr("Now") );
  reply.out() << _tntChunks[58]; // </a>\n<span class="sep">|</span>\n<a class="
#line 300 "whats_on.ecpp"
  if ( current_type == "next" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[59]; // " href="whats_on.html\?type=next&amp;mode=
#line 300 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[60]; // " id="nexthref">
#line 300 "whats_on.ecpp"
  reply.sout() << ( tr("Next") );
  reply.out() << _tntChunks[61]; // </a>\n<span class="sep">|</span>\n<span class="
#line 302 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime != "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[62]; // ">
#line 302 "whats_on.ecpp"
  reply.sout() << ( tr("What's on") );
  reply.out() << _tntChunks[63]; // </span>\n<select name="userdeftimes" size="1" id="userdeftimes" onchange="showtime(this)">\n  <option value="0"/>\n
#line 305 "whats_on.ecpp"

  std::string string_times = LiveSetup().GetTimes();
  cSplit parts(string_times, ';');
  auto part = parts.begin();
  for (int i = 0; part != parts.end(); ++i, ++part) {

  reply.out() << _tntChunks[64]; //   <option 
#line 311 "whats_on.ecpp"
 reply.out() << ( (current_fixtime != "" && *part == current_displaytime) ? "selected=\"selected\"" : "" ); 
  reply.out() << _tntChunks[65]; // value="
#line 311 "whats_on.ecpp"
  reply.sout() << ( *part );
  reply.out() << _tntChunks[66]; // "> 
#line 311 "whats_on.ecpp"
  reply.sout() << ( cToSvConcat(tr("at"), ' ', *part) );
  reply.out() << _tntChunks[67]; // </option>\n
#line 312 "whats_on.ecpp"

  }

  reply.out() << _tntChunks[68]; // </select>\n<span class="sep">|</span>\n<span class="
#line 317 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime == "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[69]; // ">
#line 317 "whats_on.ecpp"
  reply.sout() << ( tr("at") );
  reply.out() << _tntChunks[70]; // </span>\n<input type="text" size="6" name="spectime" id="spectime" value = "
#line 318 "whats_on.ecpp"
  if ( current_attime != "" )
    reply.sout() <<  current_displaytime ;
  reply.out() << _tntChunks[71]; // " onchange="showspectime(this)"/>\n<span class="sep">|</span>\n
#line 320 "whats_on.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[72]; // <a class="
#line 321 "whats_on.ecpp"
  if ( current_type == "favs" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[73]; // " href="whats_on.html\?type=favs&amp;mode=
#line 321 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[74]; // ">
#line 321 "whats_on.ecpp"
  reply.sout() << ( tr("Favorites") );
  reply.out() << _tntChunks[75]; // </a>\n<span class="sep">|</span>\n
#line 323 "whats_on.ecpp"
 }

#line 324 "whats_on.ecpp"
 if ( current_mode == "list" ) {

  reply.out() << _tntChunks[76]; // <a href="whats_on.html\?mode=detail&amp;type=
#line 325 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[77]; // &amp;attime=
#line 325 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[78]; // &amp;fixtime=
#line 325 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[79]; // ">
#line 325 "whats_on.ecpp"
  reply.sout() << ( tr("Details view") );
  reply.out() << _tntChunks[80]; // </a>\n
#line 326 "whats_on.ecpp"
 } else {

  reply.out() << _tntChunks[81]; // <a href="whats_on.html\?mode=list&amp;type=
#line 327 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[82]; // &amp;attime=
#line 327 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[83]; // &amp;fixtime=
#line 327 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[84]; // ">
#line 327 "whats_on.ecpp"
  reply.sout() << ( tr("List view") );
  reply.out() << _tntChunks[85]; // </a>\n
#line 328 "whats_on.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
